' Tento skript vytv seznam soubor v dan sloce a ukld jej do             
' html formtu. Vsledkem je zobrazen seznamu soubor v jednotlivch
' podslokch, piem kad soubor je mono dle zobrazit. Toto zobrazen
' samozejm nefunguje u vech soubor (nap. spustitelnch, jako nap. *.exe, 
' skript, soubor s neasociovanou koncovkou, atd.)

' Freeware

' Autor skriptu: Michal Novk
' Kontakt na autora: mnovak55@volny.cz



' Definice funkce ShowFileAccesInfo, kter zskv informace o jednotlivch 
' souborech

Function ShowFileAccessInfo(filespec)
   Dim fso, f, s
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFile(filespec)
   Attr = f.Attributes
   Select Case Attr
      Case Attr and 0 Attribute = "dn atributy nejsou nastaveny"
      Case Attr and 1 Attribute = "jen pro ten"
      Case Attr and 2 Attribute = "skryt"
      Case Attr and 4 Attribute = "systmov"
      Case Attr and 3 Attribute = "jen pro ten, skryt"
      Case Attr and 5 Attribute = "jen pro ten, systmov"
      Case Attr and 6 Attribute = "skryt, systmov"
      Case Attr and 7 Attribute = "jen pro ten, skryt, systmov"
      Case Attr and 32 Attribute = "archivovat"
      Case Attr and 33 Attribute = "archivovat, jen pro ten"
      Case Attr and 34 Attribute = "archivovat, skryt"
      Case Attr and 36 Attribute = "archivovat, systmov"
      Case Attr and 35 Attribute = "archivovat, jen pro ten, skryt"
      Case Attr and 37 Attribute = "archivovat, jen pro ten, systmov"
      Case Attr and 38 Attribute = "archivovat, skryt, systmov"
      Case Attr and 39 Attribute = "archivovat, jen pro ten, skryt, systmov"
' Dle je mono uvdt libovolnou kombinaci zkladnch atribut 0 - 4 a atributu 
' 64 (zstupce) a 128 (komprimovan soubor). Dal teoreticky mon hodnota 
' je 16, avak ta oznauje sloku - tento ppad neme ve skriptu nastat. 
' Tot plat pro hodnotu 8, kter oznauje diskov oddl.
      Case Attr and 64 Attribute = "zstupce"
      Case Attr and 128 Attribute = "soubor je komprimovn"
      Case Else Attribute = ""
   End Select
' Pokud nechcete zahrnout hypertextov odkazy, nahrate nsledujc dek tmto:
' s = "<i>Soubor: </i><b>" & f.Name & "</a></b><br>"
   s = "<i>Soubor: </i><b><a href=""" & filespec & """>" & f.Name & "</a></b><br>"
   s = s & "<i>Atributy: </i>" & Attribute & "<br>"
   s = s & "<i>Vytvoen: </i>" & f.DateCreated & "<br>"
   s = s & "<i>Naposledy oteven: </i>" & f.DateLastAccessed & "<br>"
   s = s & "<i>Naposledy upravovn: </i>" & f.DateLastModified & "<br>"  
   ShowFileAccessInfo = s
End Function

' Definice fuknce ShowFolderList, kter vytvo seznam soubor v dan sloce
' a pot pro kad soubor zavol funkci ShowFileAccessInfo, kter o nm zsk 
' informace 

Function ShowFolderList(folderspec)
   Dim fso, f, f1, fc, s
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.GetFolder(folderspec)
   Set fc = f.Files
   For Each f1 in fc
      s = s & ShowFileAccessInfo(f1) 
      s = s & "<br>"
   Next
   ShowFolderList = s
End Function

' Definice funkce TextOut, kter vytvo nov dek textovho souboru. 
' Jako vstup slou parametr "text"

Function TextOut(text)
  If filelist = "" Then
      textfile.Write("<i>Sloka neobsahuje dn soubory</i>" & "<br>")
      Else 
      textfile.WriteLine(text & "<br>")
  End If
End Function

' Vlastn zatek skriptu; deklarace promnnch a vytvoen potebnch objekt

Set WshShell = WScript.CreateObject("WScript.Shell")
folderpath = WshShell.SpecialFolders("MyDocuments")
' Skript neum obsluhovat situace, kdy do sloky nen mono zapisovat. 
' Pro podek je vak zavedena nov promnn "filepath", kter oznauje cestu 
' k vslednmu souboru, zatmco promnn "folderpath" oznauje zkoumanou sloku.
filepath = folderpath
If Right(folderpath, 1) = "\" Then
    filepath = Left(folderpath, Len(folderpath) - 1)
End If 
Set FSYS=CreateObject("Scripting.FileSystemObject")
Set startfolder = fsys.GetFolder(folderpath)
Set fc = startfolder.SubFolders
Set WshNetwork = WScript.CreateObject("WScript.Network")
' prava textu pro vypsn dne v tdnu.
den = Weekday(Date())
Select Case den
  Case 1 NameOfTheDay = "v nedli"
  Case 2 NameOfTheDay = "v pondl"
  Case 3 NameOfTheDay = "v ter"
  Case 4 NameOfTheDay = "ve stedu"
  Case 5 NameOfTheDay = "ve tvrtek"
  Case 6 NameOfTheDay = "v ptek"
  Case 7 NameOfTheDay = "v sobotu"
End Select

' Vytvoen html souboru, do kterho bude smrovn vstup.

Set textfile = FSYS.CreateTextFile(filepath & "\Seznam soubor " & Date() & ".html", True)

textfile.WriteLine("<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.01 Transitional//EN"">")
textfile.WriteLine("<!--// Tento soubor byl vygenerovn skriptem a obsahuje seznam soubor ve sloce " & folderpath & "\ //--!>")
textfile.WriteBlankLines(1) 
textfile.WriteLine("<html>") 
textfile.WriteBlankLines(1) 
textfile.WriteLine("<head>")
textfile.WriteLine("<meta http-equiv=""Content-Type"" content=""text/html; charset=windows-1250"">")
textfile.WriteLine("<meta name=""author"" content=""Michal Novk"">")
textfile.WriteLine("<title>Seznam soubor ve sloce " & folderpath & "\</title>")
' Odkaz na soubor style.css; ped pouitm skriptu je poteba zmnit cestu.
textfile.WriteLine("<link href=""C:\Dokumenty\Skripty a dvkov soubory\Vbs skripty\style.css"" rel=stylesheet type=text/css>")
textfile.WriteLine("<base target=""_blank"">")
' Definice barev hypertextovho odkazu na strnce.
textfile.WriteLine("</head>")
textfile.WriteBlankLines(1)
textfile.WriteLine("<body link=""#000000"" vlink=""#000000"" alink=""#000000"">")
textfile.WriteBlankLines(1)
textfile.WriteLine("<span class=""normal"">")
If Right(folderpath, 1) = "\" Then
    line = "<p><strong>Seznam soubor ve sloce " & folderpath & "</strong></p>"
  Else 
    line = "<p><strong>Seznam soubor ve sloce " & folderpath & "\</strong></p>"
End If
textfile.WriteLine(line)
textfile.WriteLine("<p><i>Vytvoeno " & NameOfTheDay & " " & Date() & " v " & Time() & ". ")
textfile.WriteLine("Soubor vytvoil uivatel " & WshNetwork.UserName & " na potai " & WshNetwork.ComputerName & ".</i></p>")
textfile.WriteLine("<br>")
If Right(folderpath, 1) = "\" Then
    line = "<p><strong>Seznam soubor v koenov sloce " & folderpath & "</strong></p>"
  Else 
    line = "<p><strong>Seznam soubor v koenov sloce " & folderpath & "\</strong></p>"
End If
textfile.WriteLine(line)
textfile.WriteLine("<blockquote>")

' Vyvoln funkce ShowFolderList s parametrem "folderpath", m se vytvo 
' seznam soubor v koenov sloce na dan cest.

filelist = ShowFolderList (folderpath)
TextOut filelist

' Prohledvn vech podsloek dan sloky. Pro kadou podsloku se vol 
' procedura SubFolders.

For Each SubF In fc
  Set MyFolder = Subf
  SubFolders Myfolder
Next

' Dokonen vytven html souboru.

textfile.WriteLine("</blockquote>")
textfile.WriteLine("</span>")
textfile.WriteBlankLines(1)
textfile.WriteLine("</body>")
textfile.WriteBlankLines(1)
textfile.WriteLine("</html>")

' Zobrazen okna s informac o spnm vytvoen seznamu

Info = MsgBox ("Seznam soubor byl spn vytvoen a uloen ve sloce " & Chr(13) & Chr(10) &  filepath & Chr(13) & Chr(10) & "pod nzvem Seznam soubor " & Date() & ".html" & ".", 64, "Seznam soubor")

' Procedura SubFolders, kter vytv seznam soubor dan podsloky (volnm 
' funkce ShowFolderList s parametrem podsloky). 
' Pokud m dan podsloka sama njak podsloky, zavol se procedura znovu
' s novm parametrem.

Sub SubFolders(ByVal AFolder)
   textfile.WriteLine("</blockquote>")
   If Right(AFolder, 1) = "\" Then
      line = "<p><strong>Seznam soubor ve sloce " & AFolder & "</strong></p>"
     Else 
      line = "<p><strong>Seznam soubor ve sloce " & AFolder & "\</strong></p>"
   End If
   textfile.WriteLine(line)
   textfile.WriteLine("<blockquote>")
   filelist = ShowFolderList (AFolder)
   TextOut (filelist)
   Set MoreFolders = AFolder.SubFolders
   For Each TempFolder In MoreFolders
     SubFolders TempFolder
   Next
End Sub


